#!/bin/sh

# This file is used by spequlos to remotely starts the cloud worker and make it join the DG

BOINC_DIR=/opt/BOINC_CLIENT
BOINC_PROJECT=http://abenaki.imag.fr/cplan/

if [ ! -d $BOINC_DIR ]
then
    echo "Error: Unable to find the directory containing BOINC at $BOINC_DIR"
    exit 1
fi

echo "Starting cloudworker for BOINC @ $BOINC_PROJECT"

#$BOINC_ACCOUNT=

cd $BOINC_DIR
./boinc_client --daemon

if [ -z $BOINC_ACCOUNT ]
then
    echo "No account provided, creating new one"
    ./boinccmd --create_account $BOINC_PROJECT spequloscw@spequlos.org cwpwd spequloscw > /tmp/account_create.log
    grep Success /tmp/account_create.log > /dev/null
    if [ $? -ne 0 ]
    then
        echo "Error: Unable to create an account for project $BOINC_PROJECT"
        exit 1
    fi
    BOINC_ACCOUNT=`grep account /tmp/account_create.log | awk '{print $NF}'` 
fi
    
echo "Account number is $BOINC_ACCOUNT"
./boinccmd --project_attach $BOINC_PROJECT $BOINC_ACCOUNT

exit $?
