#!/usr/bin/python

import time
import threading

import sys
import os
sys.path.append(os.path.join(sys.path[0],".."))
os.chdir(sys.path[0])
from tools import conf_func
from tools import log_func
log=log_func.get_spequlos_log(__file__)


class Dummy_CW_Starter(threading.Thread):

    def __init__(self,list_of_commands):
        threading.Thread.__init__(self)
        if not isinstance(list_of_commands,list) or len(list_of_commands)==0:
            raise Exception("No command to execute")
        for s in list_of_commands:
            if not isinstance(s,str):
                raise Exception("Invalid list of commands (must be a list of string)")
        self.list_of_commands = list_of_commands
        self.execution_is_success=False
        self.specific_data=None

    def run(self):
        log.info("Dummy cloud worker started")
        self.specific_data='Dummy data'
        log.info("Executing commands")        
        for cmd in self.list_of_commands:
            log.info("Not executing %s" % cmd)
        
        log.info("All commands executed, closing connection")
        self.execution_is_success = True

class Dummy_CW_Stopper(threading.Thread):

    def __init__(self,dummy_arg):
        threading.Thread.__init__(self)
        self.stop_is_success = False
        
    def run(self):
        log.info("Dummy cloud worker destroyed")
        self.stop_is_success=True


