#! /usr/bin/python

"""conf_func.py - Module for reading configuration files

""" 

import log_func
log=log_func.get_spequlos_log(__file__)


def read_config(filename):
    """Read a configuration file
    
    This readers parse a configuration with pattern:
        option=value
    on multiple lines. 
    
    Lines starting with # or ; are ignored
    
    Arguments:
    filename --- The configuration file name, as a string
    
    The function returns a dictionnary containing the set of strings' (option,values) as read in the file
    
    """ 
    params={}
    
    if not isinstance(filename,str):
        log.error("The filename argument must be a string !")
        return params    
    try:
        f = open(filename)
    except IOError as e:
        log.error("Error when opening file: %s" % filename)
        log.error(e)
    else:
        for l in f:
            if l[0]!="#" and l[0]!=";":
                splitchar = None
                if ':' in l:
                    splitchar = ':'
                elif '=' in l:
                    splitchar = '='
                if splitchar is not None:
                    param=l.strip().split(splitchar)
                    params[param[0]]=param[1]
        f.close()                 
    return params

