#!/bin/sh
#
# xtremwebconf.sh      this file sets some parameters
#
# Requirements  : ROOTDIR variable must be set before calling this file
# Params : [--jvmopts]
#          --jvmopts tells to optimize java (this may be source to troubles :( )
#
# Author : Oleg Lodygensky (lodygens -a-t- lal.in2p3.fr)
#
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
# **                DO NOT EDIT                     **
# **   This file is generated by install script     **
# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
#


#
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
#  One can modify these variables
# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
#
# the nice priority
V_NICE=10


#
# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
#   Following should not be changed
# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
#


#
# return codes
#   0 on success
#   1 on usage error
#   2 on file error (files not found)
#   3 on user error (user not found)
#   4 if not in the expected state :
#      ** stop  asked but not running
#      ** start asked but already running

#
ERROK=0
ERRUSAGE=1
ERRFILE=2
ERRCONNECTION=3
ERRSTATE=4
ERRUSER=5

#
# The middleware must not run as root
# $XWUSER is a new user created by installers
# Note that uninstaller do not remove that user: it must be done manually
#
XWUSER="xwhep"

if [ "X$ROOTDIR" = "X" ]; then
    echo "`date` [`uname -n` $PROG] ERROR : ROOTDIR is not set"
    return $ERRUSAGE
fi

XWFORMAT=""

BINDIR=$ROOTDIR/bin
BINFILE=$BINDIR/xtremweb
LIBDIR=$ROOTDIR/lib
CFGDIR=$ROOTDIR/conf
CFGFILE=$CFGDIR/$PROG.conf


[ "X$PROG" = "Xxtremweb.rpc"     ] && CFGFILE=$CFGDIR/xtremweb.client.conf
[ "X$PROG" = "Xxtremweb.tests"   ] && CFGFILE=$CFGDIR/xtremweb.client.conf
[ "X$PROG" = "Xxwhep.bridge"     ] && CFGFILE=$CFGDIR/xtremweb.client.conf
#[ "X$PROG" = "Xxtremweb.ganglia" ] && CFGFILE=$CFGDIR/xtremweb.client.conf
[ "X$PROG" = "Xxtremweb.monitor" ] && CFGFILE=$CFGDIR/xtremweb.worker.conf
[ "X$PROG" = "Xxwhep.probe"      ] && CFGFILE=$CFGDIR/xtremweb.worker.conf

if [ -f  "$HOME/.xtremweb/$PROG.conf" ] ; then
    CFGDIR="$HOME/.xtremweb/"
    CFGFILE="$CFGDIR/$PROG.conf"
fi

#
# Parse options
#
# --jvmopts command line argument to optimize java
JVMOPTS=0
while [ $# -gt 0 ]; do
    case $1 in
        "--xwformat" )
            shift
            XWFORMAT="--xwformat $1"
            ;;
        "-h" | "--help" | "--xwhelp" )
            PARAMS="--xwhelp"
            $JAVA -cp $XW_CLASSES $MAINCLASS $PARAMS
            ;;
        "--jvmopts" )
            JVMOPTS=1
            ;;
        "--xwconfig" )
            shift
            CFGFILE=" $1"
            CFGDIR=`dirname $CFGFILE`
            ;;
        * )
            PARAMS=$PARAMS" "$1
            ;;
    esac

    shift
    
done


# Feb 17 2009 : we dont use opts
JVMOPTS=0


# Config file
if [ ! -f $CFGFILE -a "X$PROG" != "Xxtremweb.ganglia" ] ; then
    CFGDIR="$HOME/.xtremweb/"
    CFGFILE="$CFGDIR/$PROG.conf"

    if [ ! -f $CFGFILE ] ; then
	echo "`date` [`uname -n` $PROG] ERROR : can't find any config file ($CFGILE)"
	return $ERRFILE
    fi
    if [ ! -r $CFGFILE ] ; then
	echo "`date` [`uname -n` $PROG] ERROR : config file is not readable ($CFGFILE)"
	return $ERRFILE
    fi
    if [ ! -s $CFGFILE ] ; then
	echo "`date` [`uname -n` $PROG] ERROR : config file is empty ($CFGFILE)"
	return $ERRFILE
    fi
fi


HOST=`uname -n`
#
# default
#
SCRATCH=/tmp

#
# Retreive tmp directory from config file
#
grep -El "^path.tmpdir" $CFGFILE > /dev/null 2>&1
if [ $? -eq 0 ] ; then
    SCRATCH=`grep -E "^[[:space:]]*path.tmpdir" $CFGFILE | cut -d '=' -f 2`
fi

LOGFILE=$SCRATCH/$PROG-$HOST.log
[ "X$PROG" = "Xxtremweb.client" ] && LOGFILE=$SCRATCH/$PROG-$USER.log
LOGBAKFILE=$LOGFILE.bak

mv -f $LOGFILE $LOGBAKFILE
touch $LOGFILE > /dev/null 2>&1
if [ $? -ne 0 ]; then
    echo "`date` [`uname -n` $PROG] WARN : con't create $LOGFILE"
fi



# this uniquely names things, if needed
TMPNAME=`date +%Y%m%d%H%M%S`

# next is the name of the created script to execute
SCRIPTTMPFILE="/tmp/$PROG.tmp.sh"



#
# main jar file
#
MAINJAR=""
[ "X$PROG" = "Xxwhep.probe" ] && MAINJAR="XtremWebStatsCollector.jar"


#
# Java available ?
#
#$JAVA -version > /dev/null 2>&1
#[ $? -ne 0 -a -f /etc/java.conf ] && . /etc/java.conf
#$JAVA -version > /dev/null 2>&1
#[ $? -ne 0 -a "$JAVA_HOME" != "" ] && export JAVA=$JAVA_HOME/bin/java

JAVA=`type -p java`
[ $? -ne 0 ] && JAVA=`type java | cut -d " " -f 3`
[ -f /etc/java.conf ] && . /etc/java.conf 
[ "X$JAVA_HOME" != "X" ] && JAVA=$JAVA_HOME/bin/java

#
# Checking Java 6
#
JAVA6=""

ls /usr/java/jre1.6* > /dev/null 2>&1
if [ $? -eq 0 ] ; then
        JAVA6=`ls /usr/java | grep jre1.6 | tail -n 1`
        JAVA="/usr/java/$JAVA6/bin/java"
fi
ls /usr/java/jdk1.6* > /dev/null 2>&1
if [ $? -eq 0 ] ; then
        JAVA6=`ls /usr/java | grep jdk1.6 | tail -n 1`
        JAVA="/usr/java/$JAVA6/bin/java"
fi



JAVAPATH=`dirname $JAVA`
JAVAHOME=`dirname $JAVAPATH`

#
# java available ?
#
if [ "X$JAVA" = "X" ]; then
    echo "`date` [`uname -n` $PROG] ERROR : can't find JAVA"
    echo "`date` [`uname -n` $PROG] ERROR : can't find JAVA" >> $LOGFILE
    return $ERRRFILE
fi



#
# java main class
#
[ "X$PROG" = "Xxtremweb.worker" ] && MAINCLASS="xtremweb.common.HTTPLauncher"
[ "X$PROG" = "Xxtremweb.client" ] && MAINCLASS="xtremweb.client.Client"
[ "X$PROG" = "Xxtremweb.rpc"    ] && MAINCLASS="xtremweb.rpcd.client.Client"
[ "X$PROG" = "Xxtremweb.server" ] && MAINCLASS="xtremweb.dispatcher.Dispatcher"
[ "X$PROG" = "Xxwhep.probe"     ] && MAINCLASS="xtremwebstatscollector.Main"



PIDFILE=""
[ -d /var/run ] && PIDFILE="/var/run/$PROG.pid"

if [ "X$PIDFILE" = "X" ]; then
    [ -d /private/var/run ] && PIDFILE="/private/var/run/$PROG.pid"
fi

if [ "X$PIDFILE" = "X" ]; then
    if [ "X$PROG" != "Xxtremweb.client" ] ; then
	echo "`date` [`uname -n` $PROG] ERROR : can't determine PIDFILE"
	echo "`date` [`uname -n` $PROG] ERROR : can't determine PIDFILE" >> $LOGFILE
	return $ERRFILE
    fi
fi

LOCKFILE=""
if [ -d /var/lock/subsys ] ; then
    LOCKFILE="/var/lock/subsys/$PROG"
    touch $LOCKFILE > /dev/null 2>&1
    [ $? -ne 0 ]  && LOCKFILE=""
fi

if [ "X$LOCKFILE" = "X" ]; then
    [ -d /var/lock ] && LOCKFILE="/var/lock/$PROG"
    touch $LOCKFILE > /dev/null 2>&1
    [ $? -ne 0 ]  && LOCKFILE=""
fi

if [ "X$LOCKFILE" = "X" ]; then
    [ -d /private/var/run ] && LOCKFILE="/private/var/run/$PROG"
    touch $LOCKFILE > /dev/null 2>&1
    [ $? -ne 0 ]  && LOCKFILE=""
fi

if [ "X$LOCKFILE"  = "X" ]; then
    [ -d /tmp ]  && LOCKFILE="/tmp/$PROG"
    touch $LOCKFILE > /dev/null 2>&1
    [ $? -ne 0 ]  && LOCKFILE=""
fi

if [ "X$LOCKFILE" = "X" ]; then
    if [ "X$PROG" != "Xxtremweb.client" ] ; then
	echo "`date` [`uname -n` $PROG] ERROR : can't determine LOCKFILE"
	echo "`date` [`uname -n` $PROG] ERROR : can't determine LOCKFILE" >> $LOGFILE
	return $ERRFILE
    fi
fi


#
# Loggert level
#
DEFAULTLOGGERLEVEL="debug"
LOGGERLEVEL=`grep -E "^[[:space:]]*logger.level" $CFGFILE | cut -d '=' -f2 | sed "s/[[:space:]][[:space:]]*//g" | tr [:upper:] [:lower:]`
[ "X$LOGGERLEVEL" = "X" ] && LOGGERLEVEL=$DEFAULTLOGGERLEVEL

JAVANETDEBUG=""
#if [ "X$LOGGERLEVEL" = "Xdebug" ]; then
#    JAVANETDEBUG="-Djavax.net.debug=all"
#fi


#
# is there any keystore ?
#
KEYSTORE=`grep -E "^[[:space:]]*SSLKeyStore" $CFGFILE | cut -d '=' -f2 | sed "s/[[:space:]][[:space:]]*//g"`
JAVATRUSTKEY=""
if [ "X$KEYSTORE" != "X" ]; then
    echo $KEYSTORE |  grep -E "^[[:space:]]*\/" > /dev/null  2>&1
    if [ $? -ne 0 ] ; then
	echo $KEYSTORE |  grep -E "^[[:space:]]*\.\.\/" > /dev/null  2>&1
	if [ $? -eq 0 ] ; then
#
# this is not an absolute path
# this is a relative path from config dir
#
	    KEYSTORE="$CFGDIR/$KEYSTORE"
	fi
    fi
    JAVATRUSTKEY="-Djavax.net.ssl.trustStore=$KEYSTORE"
fi

echo "`date` [`uname -n` $PROG] INFO : JAVATRUSTKEY=$JAVATRUSTKEY" >> $LOGFILE



#
# Set Java options
#

export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:."
export DYLD_LIBRARY_PATH="$DYLD_LIBRARY_PATH:."

JAVAOPTS="-Dxtremweb.cache=$SCRATCH -Djava.library.path=$SCRATCH:$LD_LIBRARY_PATH:$DYLD_LIBRARY_PATH -Dxtremweb.cp=$LIBDIR -server -XX:+HeapDumpOnOutOfMemoryError"
TMPFILE="/tmp/xtremweb_jvmtest.tmp"
rm -f $TMPFILE

if [ $JVMOPTS -eq 1 ] ; then
    TMPFILE="tmp."$PROG
    rm -f $TMPFILE
    JOPT="-Xdebug"
#    $JAVA $JOPT 2> $TMPFILE 1> /dev/null
    $JAVA $JOPT 2> $TMPFILE
    if [ ! -s $TMPFILE ]; then
        JAVAOPTS=$JAVAOPTS" $JOPT"
    fi
    rm -f $TMPFILE
    JOPT="-Xms128m"
#    $JAVA $JOPT  2> $TMPFILE 1> /dev/null
    $JAVA $JOPT  2> $TMPFILE
    if [ ! -s $TMPFILE ]; then
        JAVAOPTS=$JAVAOPTS" $JOPT"
    fi
    rm -f $TMPFILE
    JOPT="-Xmx128m"
#    $JAVA $JOPT  2> $TMPFILE 1> /dev/null
    $JAVA $JOPT  2> $TMPFILE
    if [ ! -s $TMPFILE ]; then
        JAVAOPTS=$JAVAOPTS" $JOPT"
    fi
    rm -f $TMPFILE
    JOPT="-Xss128m"
#    $JAVA  $JOPT  2> $TMPFILE 1> /dev/null
    $JAVA  $JOPT  2> $TMPFILE
    if [ ! -s $TMPFILE ]; then
        JAVAOPTS=$JAVAOPTS" $JOPT"
    fi
    rm -f $TMPFILE
    JOPT="-XX:+UseParallelGC"
#    $JAVA $JOPT 2> $TMPFILE 1> /dev/null
    $JAVA $JOPT 2> $TMPFILE
    if [ ! -s $TMPFILE ]; then
        JAVAOPTS=$JAVAOPTS" $JOPT"
    fi
    rm -f $TMPFILE
    JOPT="-XX:+UseAdaptiveSizePolicy"
#    $JAVA $JOPT 2> $TMPFILE 1> /dev/null
    $JAVA $JOPT 2> $TMPFILE
    if [ ! -s $TMPFILE ]; then
        JAVAOPTS=$JAVAOPTS" $JOPT"
    fi
    rm -f $TMPFILE
    JOPT="-XX:+UseTLAB"
#    $JAVA $JOPT 2> $TMPFILE 1> /dev/null
    $JAVA $JOPT 2> $TMPFILE
    if [ ! -s $TMPFILE ]; then
        JAVAOPTS=$JAVAOPTS" $JOPT"
    fi
    rm -f $TMPFILE
fi

#
# java CLASSPATH
#
XW_CLASSES=""
for i in `ls $LIBDIR/*.jar $LIBDIR/*.zip`; do
    if [ "X$i" = "Xxtremweb.jar" ]; then
#        if [ "$PROG" != "xtremweb.worker" -a "$PROG" != "xtremweb.client" ]; then
        if [ "X$PROG" != "Xxtremweb.worker" ]; then
            XW_CLASSES=$i:$XW_CLASSES
        fi
    else
        XW_CLASSES=$i:$XW_CLASSES
    fi
done

if [ "X$V_NICE" = "X" ]; then
    CMDNICE=""
else
    CMDNICE="renice $V_NICE -u $XWUSER"
fi



PROFILER=""
PROFCLASS=""
# This is the Extensible Java Profiler agent
# http://ejp.sourceforge.net/
#PROFILER="-Xruntracer"
# Don't forget to set the classpath
#PROFCLASS=/opt/ejp/lib/tracerapi.jar

# This is Yourkit java profiler
# http://www.yourkit.com
#PROFILER="-agentlib:yjpagent"
# Don't forget to set the classpath
#PROFCLASS=/
#export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:/opt/yjp-7.5.7/yjp-7.5.7/bin/linux-x86-32"
#export DYLD_LIBRARY_PATH="$DYLD_LIBRARY_PATH:/Applications/YourKit_Java_Profiler_8.0.19.app/bin/mac"


#[ "$PROFILER" != "" ] && JAVAOPTS=""


JAVA="$JAVA $JAVAOPTS $JAVANETDEBUG $JAVATRUSTKEY $PROFILER -cp $MAINJAR:$XW_CLASSES:$PROFCLASS $MAINCLASS --xwconfig $CFGFILE $XWFORMAT $PARAMS"


#
# End Of File
#
